/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2024 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebKit {

struct WebPreferencesStore;

struct SharedPreferencesForWebProcess {
    uint64_t version { 0 };
    bool allowTestOnlyIPC { false };
#if ENABLE(ENCRYPTED_MEDIA)
    bool encryptedMediaAPIEnabled { false };
#endif
    bool usesSingleWebProcess { false };
    bool appBadgeEnabled { false };
#if ENABLE(ATTACHMENT_ELEMENT)
    bool attachmentElementEnabled { false };
#endif
#if ENABLE(INPUT_TYPE_COLOR)
    bool inputTypeColorEnabled { false };
#endif
    bool contactPickerAPIEnabled { false };
#if ENABLE(DATALIST_ELEMENT)
    bool dataListElementEnabled { false };
#endif
#if ENABLE(RE_DYNAMIC_CONTENT_SCALING)
    bool useCGDisplayListsForDOMRendering { false };
#endif
    bool blobFileAccessEnforcementEnabled { false };
#if ENABLE(MEDIA_SESSION_COORDINATOR)
    bool mediaSessionCoordinatorEnabled { false };
#endif
#if ENABLE(FULLSCREEN_API)
    bool fullScreenEnabled { false };
#endif
#if ENABLE(GPU_PROCESS)
    bool useGPUProcessForDOMRenderingEnabled { false };
#endif
#if ENABLE(GPU_PROCESS) && ENABLE(WEBGL)
    bool useGPUProcessForWebGLEnabled { false };
#endif
#if ENABLE(GAMEPAD)
    bool gamepadsEnabled { false };
#endif
#if ENABLE(MODEL_ELEMENT)
    bool modelElementEnabled { false };
#endif
    bool ignoreIframeEmbeddingProtectionsEnabled { false };
    bool lockdownFontParserEnabled { false };
    bool serviceWorkersEnabled { false };
    bool shapeDetection { false };
    bool speechRecognitionEnabled { false };
    bool speechSynthesisAPIEnabled { false };
#if ENABLE(IMAGE_ANALYSIS) && ENABLE(VIDEO)
    bool textRecognitionInVideosEnabled { false };
#endif
#if ENABLE(WEB_AUTHN)
    bool webAuthenticationEnabled { false };
#endif
    bool webLocksAPIEnabled { false };
    bool webGLEnabled { false };
    bool webGPUEnabled { false };
    bool webTransportEnabled { false };
#if ENABLE(WEBXR)
    bool webXREnabled { false };
#endif

    bool operator==(const SharedPreferencesForWebProcess&) const = default;
};

SharedPreferencesForWebProcess sharedPreferencesForWebProcess(const WebPreferencesStore&);
bool updateSharedPreferencesForWebProcess(SharedPreferencesForWebProcess&, const WebPreferencesStore&);

} // namespace WebKit
