/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2011 Google Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GOOGLE, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebCore {

enum class EventInterfaceType {
    Invalid = 0,
#if ENABLE(APPLE_PAY)
    ApplePayCancelEvent = 1,
    ApplePayPaymentAuthorizedEvent = 2,
    ApplePayPaymentMethodSelectedEvent = 3,
    ApplePayShippingContactSelectedEvent = 4,
    ApplePayShippingMethodSelectedEvent = 5,
    ApplePayValidateMerchantEvent = 6,
#endif
#if ENABLE(APPLE_PAY_COUPON_CODE)
    ApplePayCouponCodeChangedEvent = 7,
#endif
#if ENABLE(DECLARATIVE_WEB_PUSH)
    PushNotificationEvent = 8,
#endif
#if ENABLE(DEVICE_ORIENTATION)
    DeviceMotionEvent = 9,
    DeviceOrientationEvent = 10,
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    MediaEncryptedEvent = 11,
    MediaKeyMessageEvent = 12,
#endif
#if ENABLE(GAMEPAD)
    GamepadEvent = 13,
#endif
#if ENABLE(IOS_GESTURE_EVENTS) || ENABLE(MAC_GESTURE_EVENTS)
    GestureEvent = 14,
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    WebKitMediaKeyMessageEvent = 15,
    WebKitMediaKeyNeededEvent = 16,
#endif
#if ENABLE(MEDIA_RECORDER)
    BlobEvent = 17,
    MediaRecorderErrorEvent = 18,
#endif
#if ENABLE(MEDIA_SOURCE)
    BufferedChangeEvent = 19,
#endif
#if ENABLE(MEDIA_STREAM)
    MediaStreamTrackEvent = 20,
    OverconstrainedErrorEvent = 21,
#endif
#if ENABLE(NOTIFICATION_EVENT)
    NotificationEvent = 22,
#endif
#if ENABLE(ORIENTATION_EVENTS)
#endif
#if ENABLE(PAYMENT_REQUEST)
    MerchantValidationEvent = 23,
    PaymentMethodChangeEvent = 24,
    PaymentRequestUpdateEvent = 25,
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
    PictureInPictureEvent = 26,
#endif
#if ENABLE(SPEECH_SYNTHESIS)
    SpeechSynthesisErrorEvent = 27,
    SpeechSynthesisEvent = 28,
#endif
#if ENABLE(TOUCH_EVENTS)
    TouchEvent = 29,
#endif
#if ENABLE(VIDEO)
    TrackEvent = 30,
#endif
#if ENABLE(WEBGL)
    WebGLContextEvent = 31,
#endif
#if ENABLE(WEBXR)
    XRInputSourceEvent = 32,
    XRInputSourcesChangeEvent = 33,
    XRReferenceSpaceEvent = 34,
    XRSessionEvent = 35,
#endif
#if ENABLE(WEBXR_LAYERS)
    XRLayerEvent = 36,
#endif
#if ENABLE(WEB_AUDIO)
    AudioProcessingEvent = 37,
    OfflineAudioCompletionEvent = 38,
#endif
#if ENABLE(WEB_RTC)
    RTCDTMFToneChangeEvent = 39,
    RTCDataChannelEvent = 40,
    RTCErrorEvent = 41,
    RTCPeerConnectionIceErrorEvent = 42,
    RTCPeerConnectionIceEvent = 43,
    RTCRtpSFrameTransformErrorEvent = 44,
    RTCTrackEvent = 45,
    RTCTransformEvent = 46,
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET_AVAILABILITY_API)
    WebKitPlaybackTargetAvailabilityEvent = 47,
#endif
    AnimationPlaybackEvent = 48,
    BackgroundFetchEvent = 49,
    BackgroundFetchUpdateUIEvent = 50,
    BeforeUnloadEvent = 51,
    CSSAnimationEvent = 52,
    CSSTransitionEvent = 53,
    ClipboardEvent = 54,
    CloseEvent = 55,
    CommandEvent = 56,
    CompositionEvent = 57,
    ContentVisibilityAutoStateChangeEvent = 58,
    CookieChangeEvent = 59,
    CustomEvent = 60,
    DragEvent = 61,
    ErrorEvent = 62,
    Event = 63,
    ExtendableCookieChangeEvent = 64,
    ExtendableEvent = 65,
    ExtendableMessageEvent = 66,
    FetchEvent = 67,
    FocusEvent = 68,
    FormDataEvent = 69,
    GPUUncapturedErrorEvent = 70,
    HashChangeEvent = 71,
    IDBVersionChangeEvent = 72,
    InputEvent = 73,
    KeyboardEvent = 74,
    MediaQueryListEvent = 75,
    MessageEvent = 76,
    MouseEvent = 77,
    MutationEvent = 78,
    NavigateEvent = 79,
    NavigationCurrentEntryChangeEvent = 80,
    PageRevealEvent = 81,
    PageSwapEvent = 82,
    PageTransitionEvent = 83,
    PointerEvent = 84,
    PopStateEvent = 85,
    ProgressEvent = 86,
    PromiseRejectionEvent = 87,
    PushEvent = 88,
    PushSubscriptionChangeEvent = 89,
    SecurityPolicyViolationEvent = 90,
    SpeechRecognitionErrorEvent = 91,
    SpeechRecognitionEvent = 92,
    StorageEvent = 93,
    SubmitEvent = 94,
    TextEvent = 95,
    ToggleEvent = 96,
    UIEvent = 97,
    WheelEvent = 98,
    XMLHttpRequestProgressEvent = 99,
};

} // namespace WebCore
