/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUTextureAspect.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(GPUTextureAspect enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("all"),
        MAKE_STATIC_STRING_IMPL("stencil-only"),
        MAKE_STATIC_STRING_IMPL("depth-only"),
    };
    static_assert(static_cast<size_t>(GPUTextureAspect::All) == 0, "GPUTextureAspect::All is not 0 as expected");
    static_assert(static_cast<size_t>(GPUTextureAspect::StencilOnly) == 1, "GPUTextureAspect::StencilOnly is not 1 as expected");
    static_assert(static_cast<size_t>(GPUTextureAspect::DepthOnly) == 2, "GPUTextureAspect::DepthOnly is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, GPUTextureAspect enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<GPUTextureAspect> parseEnumerationFromString<GPUTextureAspect>(const String& stringValue)
{
    static constexpr std::pair<ComparableASCIILiteral, GPUTextureAspect> mappings[] = {
        { "all", GPUTextureAspect::All },
        { "depth-only", GPUTextureAspect::DepthOnly },
        { "stencil-only", GPUTextureAspect::StencilOnly },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<GPUTextureAspect> parseEnumeration<GPUTextureAspect>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<GPUTextureAspect>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<GPUTextureAspect>()
{
    return "\"all\", \"stencil-only\", \"depth-only\""_s;
}

} // namespace WebCore
