/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(GAMEPAD)

#include "GamepadHapticActuator.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSGamepadHapticActuator : public JSDOMWrapper<GamepadHapticActuator> {
public:
    using Base = JSDOMWrapper<GamepadHapticActuator>;
    static JSGamepadHapticActuator* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<GamepadHapticActuator>&& impl)
    {
        auto& vm = globalObject->vm();
        JSGamepadHapticActuator* ptr = new (NotNull, JSC::allocateCell<JSGamepadHapticActuator>(vm)) JSGamepadHapticActuator(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(vm);
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static GamepadHapticActuator* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
protected:
    JSGamepadHapticActuator(JSC::Structure*, JSDOMGlobalObject&, Ref<GamepadHapticActuator>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};

class JSGamepadHapticActuatorOwner final : public JSC::WeakHandleOwner {
public:
    bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::AbstractSlotVisitor&, ASCIILiteral*) final;
    void finalize(JSC::Handle<JSC::Unknown>, void* context) final;
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, GamepadHapticActuator*)
{
    static NeverDestroyed<JSGamepadHapticActuatorOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(GamepadHapticActuator* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, GamepadHapticActuator&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, GamepadHapticActuator* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<GamepadHapticActuator>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<GamepadHapticActuator>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<GamepadHapticActuator> {
    using WrapperClass = JSGamepadHapticActuator;
    using ToWrappedReturnType = GamepadHapticActuator*;
};
String convertEnumerationToString(GamepadHapticActuator::Type);
template<> JSC::JSString* convertEnumerationToJS(JSC::VM&, GamepadHapticActuator::Type);

template<> std::optional<GamepadHapticActuator::Type> parseEnumerationFromString<GamepadHapticActuator::Type>(const String&);
template<> std::optional<GamepadHapticActuator::Type> parseEnumeration<GamepadHapticActuator::Type>(JSC::JSGlobalObject&, JSC::JSValue);
template<> ASCIILiteral expectedEnumerationValues<GamepadHapticActuator::Type>();

String convertEnumerationToString(GamepadHapticActuator::Result);
template<> JSC::JSString* convertEnumerationToJS(JSC::VM&, GamepadHapticActuator::Result);

template<> std::optional<GamepadHapticActuator::Result> parseEnumerationFromString<GamepadHapticActuator::Result>(const String&);
template<> std::optional<GamepadHapticActuator::Result> parseEnumeration<GamepadHapticActuator::Result>(JSC::JSGlobalObject&, JSC::JSValue);
template<> ASCIILiteral expectedEnumerationValues<GamepadHapticActuator::Result>();


} // namespace WebCore

#endif // ENABLE(GAMEPAD)
