/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSIdentityRequestProvider.h"

#include "JSDOMConvertEnumeration.h"
#include "JSIdentityCredentialProtocol.h"
#include "JSOpenID4VPRequest.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<IdentityRequestProvider>> convertDictionary<IdentityRequestProvider>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    IdentityRequestProvider result;
    JSValue protocolValue;
    if (isNullOrUndefined)
        protocolValue = jsUndefined();
    else {
        protocolValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "protocol"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (protocolValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "protocol"_s, "IdentityRequestProvider"_s, "IdentityCredentialProtocol"_s);
        return ConversionResultException { };
    }
    auto protocolConversionResult = convert<IDLEnumeration<IdentityCredentialProtocol>>(lexicalGlobalObject, protocolValue);
    if (UNLIKELY(protocolConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.protocol = protocolConversionResult.releaseReturnValue();
    JSValue requestValue;
    if (isNullOrUndefined)
        requestValue = jsUndefined();
    else {
        requestValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "request"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (requestValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "request"_s, "IdentityRequestProvider"_s, "OpenID4VPRequest"_s);
        return ConversionResultException { };
    }
    auto requestConversionResult = convert<IDLDictionary<OpenID4VPRequest>>(lexicalGlobalObject, requestValue);
    if (UNLIKELY(requestConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.request = requestConversionResult.releaseReturnValue();
    return result;
}

} // namespace WebCore
