/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(MATHML)

#include "JSDOMWrapper.h"
#include "JSElement.h"
#include "MathMLElement.h"

namespace WebCore {

class JSMathMLElement : public JSElement {
public:
    using Base = JSElement;
    using DOMWrapped = MathMLElement;
    static JSMathMLElement* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<MathMLElement>&& impl)
    {
        auto& vm = globalObject->vm();
        JSMathMLElement* ptr = new (NotNull, JSC::allocateCell<JSMathMLElement>(vm)) JSMathMLElement(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(vm);
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static MathMLElement* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::JSType(JSElementType), StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    mutable JSC::WriteBarrier<JSC::Unknown> m_attributeStyleMap;
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    DECLARE_VISIT_CHILDREN;

    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    MathMLElement& wrapped() const
    {
        return static_cast<MathMLElement&>(Base::wrapped());
    }

    Ref<MathMLElement> protectedWrapped() const;

protected:
    JSMathMLElement(JSC::Structure*, JSDOMGlobalObject&, Ref<MathMLElement>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};


template<> struct JSDOMWrapperConverterTraits<MathMLElement> {
    using WrapperClass = JSMathMLElement;
    using ToWrappedReturnType = MathMLElement*;
};

} // namespace WebCore

#endif // ENABLE(MATHML)
