/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM) && ENABLE(WEB_AUDIO)

#include "JSMediaStreamAudioSourceOptions.h"

#include "JSDOMConvertInterface.h"
#include "JSMediaStream.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(MEDIA_STREAM) && ENABLE(WEB_AUDIO)

template<> ConversionResult<IDLDictionary<MediaStreamAudioSourceOptions>> convertDictionary<MediaStreamAudioSourceOptions>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    MediaStreamAudioSourceOptions result;
    JSValue mediaStreamValue;
    if (isNullOrUndefined)
        mediaStreamValue = jsUndefined();
    else {
        mediaStreamValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "mediaStream"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (mediaStreamValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "mediaStream"_s, "MediaStreamAudioSourceOptions"_s, "MediaStream"_s);
        return ConversionResultException { };
    }
    auto mediaStreamConversionResult = convert<IDLInterface<MediaStream>>(lexicalGlobalObject, mediaStreamValue);
    if (UNLIKELY(mediaStreamConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.mediaStream = mediaStreamConversionResult.releaseReturnValue();
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM) && ENABLE(WEB_AUDIO)
