/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSMeteringMode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(MeteringMode enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("none"),
        MAKE_STATIC_STRING_IMPL("manual"),
        MAKE_STATIC_STRING_IMPL("single-shot"),
        MAKE_STATIC_STRING_IMPL("continuous"),
    };
    static_assert(static_cast<size_t>(MeteringMode::None) == 0, "MeteringMode::None is not 0 as expected");
    static_assert(static_cast<size_t>(MeteringMode::Manual) == 1, "MeteringMode::Manual is not 1 as expected");
    static_assert(static_cast<size_t>(MeteringMode::SingleShot) == 2, "MeteringMode::SingleShot is not 2 as expected");
    static_assert(static_cast<size_t>(MeteringMode::Continuous) == 3, "MeteringMode::Continuous is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, MeteringMode enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<MeteringMode> parseEnumerationFromString<MeteringMode>(const String& stringValue)
{
    static constexpr std::pair<ComparableASCIILiteral, MeteringMode> mappings[] = {
        { "continuous", MeteringMode::Continuous },
        { "manual", MeteringMode::Manual },
        { "none", MeteringMode::None },
        { "single-shot", MeteringMode::SingleShot },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<MeteringMode> parseEnumeration<MeteringMode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<MeteringMode>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<MeteringMode>()
{
    return "\"none\", \"manual\", \"single-shot\", \"continuous\""_s;
}

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
