/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(NOTIFICATION_EVENT)

#include "JSDOMConvertDictionary.h"
#include "JSDOMWrapper.h"
#include "JSExtendableEvent.h"
#include "NotificationEvent.h"

namespace WebCore {

class JSNotificationEvent : public JSExtendableEvent {
public:
    using Base = JSExtendableEvent;
    using DOMWrapped = NotificationEvent;
    static JSNotificationEvent* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<NotificationEvent>&& impl)
    {
        auto& vm = globalObject->vm();
        JSNotificationEvent* ptr = new (NotNull, JSC::allocateCell<JSNotificationEvent>(vm)) JSNotificationEvent(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(vm);
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::JSType(JSEventType), StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    NotificationEvent& wrapped() const
    {
        return static_cast<NotificationEvent&>(Base::wrapped());
    }

    Ref<NotificationEvent> protectedWrapped() const;

protected:
    JSNotificationEvent(JSC::Structure*, JSDOMGlobalObject&, Ref<NotificationEvent>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, NotificationEvent&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, NotificationEvent* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<NotificationEvent>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<NotificationEvent>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<NotificationEvent> {
    using WrapperClass = JSNotificationEvent;
    using ToWrappedReturnType = NotificationEvent*;
};
#if ENABLE(NOTIFICATION_EVENT)

template<> ConversionResult<IDLDictionary<NotificationEvent::Init>> convertDictionary<NotificationEvent::Init>(JSC::JSGlobalObject&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(NOTIFICATION_EVENT)
