/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSScrollToOptions.h"

#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertOptional.h"
#include "JSScrollBehavior.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<ScrollToOptions>> convertDictionary<ScrollToOptions>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    ScrollToOptions result;
    JSValue behaviorValue;
    if (isNullOrUndefined)
        behaviorValue = jsUndefined();
    else {
        behaviorValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "behavior"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto behaviorConversionResult = convertOptionalWithDefault<IDLEnumeration<ScrollBehavior>>(lexicalGlobalObject, behaviorValue, [&]() -> ConversionResult<IDLEnumeration<ScrollBehavior>> { return Converter<IDLEnumeration<ScrollBehavior>>::ReturnType { ScrollBehavior::Auto }; });
    if (UNLIKELY(behaviorConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.behavior = behaviorConversionResult.releaseReturnValue();
    JSValue leftValue;
    if (isNullOrUndefined)
        leftValue = jsUndefined();
    else {
        leftValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "left"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!leftValue.isUndefined()) {
        auto leftConversionResult = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, leftValue);
        if (UNLIKELY(leftConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.left = leftConversionResult.releaseReturnValue();
    }
    JSValue topValue;
    if (isNullOrUndefined)
        topValue = jsUndefined();
    else {
        topValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "top"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!topValue.isUndefined()) {
        auto topConversionResult = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, topValue);
        if (UNLIKELY(topConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.top = topConversionResult.releaseReturnValue();
    }
    return result;
}

} // namespace WebCore
