/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_CODECS)

#include "JSDOMConvertDictionary.h"
#include "JSDOMWrapper.h"
#include "JSEventTarget.h"
#include "WebCodecsVideoDecoder.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSWebCodecsVideoDecoder : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = WebCodecsVideoDecoder;
    static JSWebCodecsVideoDecoder* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<WebCodecsVideoDecoder>&& impl)
    {
        auto& vm = globalObject->vm();
        JSWebCodecsVideoDecoder* ptr = new (NotNull, JSC::allocateCell<JSWebCodecsVideoDecoder>(vm)) JSWebCodecsVideoDecoder(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(vm);
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static WebCodecsVideoDecoder* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    DECLARE_VISIT_CHILDREN;
    template<typename Visitor> void visitAdditionalChildren(Visitor&);

    template<typename Visitor> static void visitOutputConstraints(JSCell*, Visitor&);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    WebCodecsVideoDecoder& wrapped() const
    {
        return static_cast<WebCodecsVideoDecoder&>(Base::wrapped());
    }

    Ref<WebCodecsVideoDecoder> protectedWrapped() const;

protected:
    JSWebCodecsVideoDecoder(JSC::Structure*, JSDOMGlobalObject&, Ref<WebCodecsVideoDecoder>&&);

    DECLARE_DEFAULT_FINISH_CREATION;
};

class JSWebCodecsVideoDecoderOwner final : public JSC::WeakHandleOwner {
public:
    bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::AbstractSlotVisitor&, ASCIILiteral*) final;
    void finalize(JSC::Handle<JSC::Unknown>, void* context) final;
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, WebCodecsVideoDecoder*)
{
    static NeverDestroyed<JSWebCodecsVideoDecoderOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(WebCodecsVideoDecoder* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, WebCodecsVideoDecoder&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebCodecsVideoDecoder* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<WebCodecsVideoDecoder>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<WebCodecsVideoDecoder>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<WebCodecsVideoDecoder> {
    using WrapperClass = JSWebCodecsVideoDecoder;
    using ToWrappedReturnType = WebCodecsVideoDecoder*;
};
#if ENABLE(WEB_CODECS)

template<> ConversionResult<IDLDictionary<WebCodecsVideoDecoder::Init>> convertDictionary<WebCodecsVideoDecoder::Init>(JSC::JSGlobalObject&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(WEB_CODECS)
